博客
关于我
强烈建议你试试无所不能的chatGPT,快点击我
NOJ 1651 Red packet(二分)
阅读量:4919 次
发布时间:2019-06-11

本文共 2135 字,大约阅读时间需要 7 分钟。

 

  • [1651] Red packet

  • 时间限制: 1000 ms 内存限制: 65535 K
  • 问题描述
  • New Year is coming! Our big boss Wine93 will distribute some “Red Package”, just like Alipay and Wechat.

    Wine93 has m yuan, he decides to distribute them to n people and everyone can get some money(0 yuan is not allowed and everyone’s money is an integer), Now k people has gotten money, it’s your turn to get “Red Package”, you want to know, at least how much money to give you, then you can must become the “lucky man”. and the m yuan must be used out.

    Noting that if someone’s money is strictly much than others’, than he is “lucky man”.

  • 输入
  • Input starts with an integer T (T <= 50) denoting the number of test case.
    For each test case, three integers n, m, k (1 <= k < n <= 100000, 0< m <= 100000000) will be given.
    Next line contains k integers, denoting the money that k people get. You can assume that the k integers’ summation is no more than m.
  • 输出
  • Ouput the least money that you need to become the “lucky man”, if it is impossible, output “Impossible” (no quote).
  • 样例输入
  • 33 5 22 14 10 22 34 15 23 5
  • 样例输出
  • Impossible46

 

 

以前红包专场的题目,当时实在是水平低下,天真的以为可以拿点钱,结果被爆0血虐(Orz各位学长学姐老司机们)。

于是现在又回来噜一下这题,发现挺简单的……就是二分的时候剩下的除我之外其他人的钱忘记减1,WA两次才发现……

主要思路:记录剩余的钱为res,出现过的最高红包额度记为maxm,特判掉impossib的情况之后,二分的左端点肯定是maxm+1,右端点显然要奢侈一点取最好情况即剩下的人均只分到1元,那么我就有res-(n-k-1)元,然后唯一的竞争对手就是另外一个人,他有res-(n-k-2)-mid元,条件是不能让他大于等于我,然后二分就可以了……,以前还傻乎乎地看不懂二分的条件还跑论坛里问别人这是什么意思…………Naive。

代码:

#include
#include
#include
#include
#include
#include
#include
#include
#include
#include
#include
#include
#include
#include
using namespace std;#define INF 0x3f3f3f3f#define CLR(x,y) memset(x,y,sizeof(x))#define LC(x) (x<<1)#define RC(x) ((x<<1)+1)#define MID(x,y) ((x+y)>>1)typedef pair
pii;typedef __int64 LL;const double PI=acos(-1.0);int main(void){ int n,m,l,r,mid,ans,temp; int i,k; int tcase; scanf("%d",&tcase); while (tcase--) { scanf("%d%d%d",&n,&m,&k); int maxm=-1; int sum=0; int res=0; for (i=0; i
maxm) maxm=temp; } res=m-sum; if(res
>1; if(oth-mid

转载于:https://www.cnblogs.com/Blackops/p/5766258.html

你可能感兴趣的文章
JavaScript高级编程——Array数组迭代(every()、filter()、foreach()、map()、some(),归并(reduce() 和reduceRight() ))...
查看>>
poj 3070 Fibonacci 矩阵快速幂
查看>>
网桥知识点学习
查看>>
Android动态改变工程依赖
查看>>
for循环变量声明为 final
查看>>
对法拉奇的看法
查看>>
linux3.4.2之DMA驱动完整程序
查看>>
AC自动机(转载)
查看>>
用IrisSkin2.dll美化你的WinForm --zt
查看>>
[leetcode](4.21)3. 最长重复子串
查看>>
ASP.NET MVC 实现与SQLSERVER的依赖缓存
查看>>
run()和start()的区别
查看>>
Windows高手纯键盘操作
查看>>
zoj 2339 Hyperhuffman 哈夫曼编码 (4-C)
查看>>
【Git版本控制】git中reset命令的详解
查看>>
Ultimate SEO URLs静态网址时标点符号自动忽略,如何解决?
查看>>
20180222小测
查看>>
ElasticSearch自定义分析器-集成结巴分词插件
查看>>
PHP语法查询表
查看>>
影响工作效率的原因种种
查看>>